#include "Demo1Host.h"

#include <stdio.h>
#include <string.h>

#include "Util.h"
#include "SourceRoutingInit.h"

namespace Demo1 {

Define_Module(Demo1Host);

static const char * const SRC = "SRC";

void Demo1Host::initialize() {
    YARC::Host::initialize();
    
    id = par("id");
}
    
std::pair<YARC::HeadFlit*, int> Demo1Host::sendNewPacket(const char (&sideband)[2]) {
    if (id == 0 || id == 2) {
        if (sideband[0] != 0) {
            return Host::sendNewPacket(sideband);
        }
        
        YARC::HeadFlit *head = new YARC::HeadFlit();

        YARC::addLongPar(head, SRC, id);
        YARC::addLongPar(head, HOP_COUNT_ATTR, 1);
        if (id == 0) {
            YARC::addLongPar(head, "HOP_0", 1);
        } else if (id == 2) {
            YARC::addLongPar(head, "HOP_0", 3);
        }

        return std::pair<YARC::HeadFlit*, int>(head, 20);
        //return std::pair<YARC::HeadFlit*, int>(head, YARC::MAX_PACKET_LENGTH);        
    } else {    
        return Host::sendNewPacket(sideband);
    }
}

void Demo1Host::receiveNewPacket(int length, YARC::HeadFlit *head) {
    //printf("%f\n", head->par(YARC::RECEIVE_TIME).doubleValue());
    //printf("%f\n", head->par(YARC::SEND_TIME).doubleValue());
    
    double delay = head->par(YARC::RECEIVE_TIME).doubleValue() - head->par(YARC::SEND_TIME).doubleValue();
            
    printf("Demo1Host id=%d RX L=%d Delay=%.3f Src=%ld\n", id, length, delay, YARC::xtrLongPar(head, SRC));
}

}
