#ifndef CLOCKEDBUFFERARRAY_H_
#define CLOCKEDBUFFERARRAY_H_

#include <omnetpp.h>
#include <cgate.h>

#include "Messages_m.h"

namespace YARC {

class ClockedBufferArray: public cSimpleModule {
protected:
    
    virtual void initialize();
    virtual void handleMessage(cMessage *msg);
    
    int getPeerCount();
    int getCurrentOutputVC();
    int getCurrentOutputSourceQueue();
    
    virtual bool canSendHeadFlit(HeadFlit *head) = 0;  
    virtual bool canSendFlit(Flit*) = 0;
    virtual bool canSendTailFlit(TailFlit *tail) = 0;
    
private:
    void roundRobinStep(int &peerId, int &vcId);
    void updateSideband();
    void output();

    cGate *in;
    cGate *out;
    cGate *congestion; 

    simtime_t clockStart;
    simtime_t clockPeriod;
    
    int peerCount;
    int bufferThreshold;
    int bufferDepth;
    
    cQueue (*queues)[2];
    char (*inputCongested)[2];
    char *currentInputVC;    
    
    int lastOutputSourceQueue;
    int lastOutputVC;
    
    int currentOutputSourceQueue;
    int currentOutputVC;
};

}

#endif /* CLOCKEDBUFFERARRAY_H_ */
