#ifndef HOST_H_
#define HOST_H_

#include <omnetpp.h>
#include <cgate.h>
#include <utility>

#include "Util.h"

namespace YARC {

const char * const SEND_TIME = "__SEND_TIME__";
const char * const RECEIVE_TIME = "__RECEIVE_TIME__";

class Host: public cSimpleModule {
protected:
    
    virtual void initialize();
    virtual void handleMessage(cMessage *msg);
    
    virtual std::pair<HeadFlit*, int> sendNewPacket(const char (&sideband)[2]);
    virtual void receiveNewPacket(int length, HeadFlit *head);
    
    double getInvScale();
    
private:
    
    cGate *linkRx;
    cGate *linkTx;    
    
    simtime_t clockStart;
    simtime_t clockPeriod;
    
    HeadFlit *curTxHead;
    int curTxLength;
    char sideband[2];
    
    HeadFlit *curRxHead;
    int curRxLength;
    bool rxDone;
    
    void clock();
};

}

#endif /* HOST_H_ */
