#ifndef TILEINPUTQUEUES_H_
#define TILEINPUTQUEUES_H_

#include <omnetpp.h>
#include <cgate.h>

namespace YARC {

class TileInputQueues: public cSimpleModule {
protected:
    
    virtual void initialize();
    virtual void handleMessage(cMessage *msg);
    
private:
     
    cGate *in;
    cGate *out;
    cGate *ack;
    cGate *sideband;
    
    simtime_t clockStart;
    simtime_t clockPeriod;

    cQueue queues[2];
    char isCongested[2];
    int threshold;
    int depth;    
    
    bool pendingAck;
    
    int currentInputVC;     
    int currentOutputVC;
    int nextOutputVC;
    
    void roundRobinStep();
    void acceptFlit(cMessage *msg);
    void updateSideband();
    void sendFlit();
};

}

#endif /* TILEINPUTQUEUES_H_ */
