#include "Util.h"

//#include <map>
//#include <utility>

#include <assert.h>
#include <string.h>
#include <stdio.h>

#include "Messages_m.h"

namespace YARC {

static RoutingFuncPtr routingFunc = NULL;

void setRoutingFunc(RoutingFuncPtr func) {
    routingFunc = func;
}

RoutingFuncPtr getRoutingFunc() {
    return routingFunc;
}
/*
static std::map<int, void**> perSwitchStorage;

void** getPerSwitchStorage(int switchId) {
    try {
        void** &storage = perSwitchStorage.at(switchId);
        
        return storage;
    } catch (std::out_of_range &e) {
        void **storage = (void**)malloc(sizeof(void*));
        
        perSwitchStorage.insert(std::make_pair(switchId, storage));
        
        return storage;
    }
}
*/
void reflectGateVector(cSimpleModule *mod, const char *name, cGate **&arr, int &size, int &baseId) {
    size = mod->gateSize(name);
    
    arr = new cGate*[size];
    memset(arr, 0, sizeof(cGate*)*size);
    
    baseId = mod->gateBaseId(name);
    for (int i=0; i < size; i++) {
        cGate *port = mod->gate(baseId + i);
        arr[i] = port;
    }
}
/*
void reflectClock(cSimpleModule *mod, simtime_t &clockPeriod, simtime_t &clockStart) {
    clockPeriod = mod->par("clockPeriod");
    clockStart  = mod->par("clockStart");
}
*/

void copySideband(Flit *src, Sideband *dst) {
    dst->setSideBand(0, src->getSideBand(0));
    dst->setSideBand(1, src->getSideBand(1));
}

void copySideband(Flit *src, char (&dst)[2]) {
    dst[0] = src->getSideBand(0);
    dst[1] = src->getSideBand(1);
}

void copySideband(Sideband *src, char (&dst)[2]) {
    dst[0] = src->getSideBand(0);
    dst[1] = src->getSideBand(1);
}

void copySideband(char (&src)[2], Sideband *dst) {
    dst->setSideBand(0, src[0]);
    dst->setSideBand(1, src[1]);
}

void copySideband(char (&src)[2], Flit *dst) {
    dst->setSideBand(0, src[0]);
    dst->setSideBand(1, src[1]);
}

void copySideband(char (&src)[2], char (&dst)[2]) {
    dst[0] = src[0];
    dst[1] = src[1];
}

int tokenizeString(const char *&string, char **&tokens) {
    int length = strlen(string);
    
    if (string[length - 1] == ' ') {
        assert(false);
    }
    
    for (int i=0; i < length - 1; i++) {
        if (string[i] == ' ' && string[i+1] == ' ') {
            assert(false);
        }
    }
    
    int tokenCount = 0;
    for (int i=0; i < length; i++) {
        if (string[i] == ' ') {
            tokenCount++;
        }
    }
    tokenCount++;
    
    tokens = new char*[tokenCount];
    for (int curToken=0,left=0,right=0; right < length; right++) {
        if (string[right] == ' ' || right == length - 1) {
            // For whatever reason mingw doesn't seem to have strndup
            //tokens[curToken] = strndup((&string[left]), right - left + 1);
            
            int len = right - left + 1;
            tokens[curToken] = new char[len];
            memset(tokens[curToken], 0, sizeof(char)*(len));
            memmove(tokens[curToken], &(string[left]), len-1);
            
            //printf("%s\n",tokens[curToken]);
            
            curToken++;
            left = right + 1;
        }
    }
    
    return tokenCount;
}

long xtrLongPar(cMessage *msg, const char* name) {
    long l = msg->par(name).longValue();
    cObject *obj = msg->removeObject(name);
    delete obj;
    
    return l;
}

void addLongPar(cMessage *msg, const char* name, long value) {
    assert(!msg->hasPar(name));
    msg->addPar(name).setLongValue(value);
}

void addCStringPar(cMessage *msg, const char* name, const char* value) {
    assert(!msg->hasPar(name));
    msg->addPar(name).setStringValue(value);
}

char *newBuff(int l) {
    char *buff = new char[l];
    memset(buff, 0, sizeof(char) * l);
    
    return buff;
}

void watchFlag(const char *name, char &var) {
    new cGenericAssignableWatch<char>(name, var);
}

}

std::ostream &operator<<(std::ostream &stream, char &c) {
    stream << int(c);

    return stream;
}

