#include "SourceRoutingInit.h"

#include <assert.h>
#include <string.h>

#include "Util.h"
#include "Messages_m.h"

namespace Demo1 {

Define_Module(SourceRoutingInit);

static int SourceRoutingFunc(YARC::HeadFlit *flit, int switchId, const char *paramString) {
    const int BUFF_SIZE = 100;
    
    int hopCount = YARC::xtrLongPar(flit, HOP_COUNT_ATTR);
    hopCount--;
    if (hopCount > 0) {
        YARC::addLongPar(flit, HOP_COUNT_ATTR, hopCount);
    }
    
    char hopIdS[BUFF_SIZE] = {0};    
    snprintf(hopIdS, BUFF_SIZE, "%d", hopCount);
    
    char hopParName[BUFF_SIZE] = {0};
    snprintf(hopParName,  BUFF_SIZE, "%s%s", HOP_ATTR_PREFIX, hopIdS);
    
    int hop = YARC::xtrLongPar(flit, hopParName);
    
    return hop;
}

void SourceRoutingInit::initialize() {
    YARC::setRoutingFunc(SourceRoutingFunc);
}

void SourceRoutingInit::handleMessage(cMessage *msg) {
    assert(false);
}

}
