#ifndef UTIL_H_
#define UTIL_H_

#include <iostream>

std::ostream &operator<<(std::ostream &stream, char &c);

#include <omnetpp.h>
#include <cgate.h>

#include "Messages_m.h"

namespace YARC {

typedef int (*RoutingFuncPtr)(HeadFlit *flit, int switchId, const char *paramString);

void setRoutingFunc(RoutingFuncPtr func);
RoutingFuncPtr getRoutingFunc();

//const int MAX_PACKET_LENGTH = 19;

const char * const MULDEX_TAG_ATTR  = "__TAG";
const char * const UNICAST_SRC_ATTR = "__SRC";
const char * const UNICAST_DST_ATTR = "__DST";
const char * const OUTPUT_PORT_ATTR = "OUTPUT_PORT";

//void** getPerSwitchStorage(int switchId);

void reflectGateVector(cSimpleModule *mod, const char *name, cGate **&arr, int &size, int &baseId);
//void reflectClock(cSimpleModule *mod, simtime_t &clockPeriod, simtime_t &clockStart);

void copySideband(Flit *src, Sideband *dst);
void copySideband(Flit *src, char (&dst)[2]);
void copySideband(Sideband *src, char (&dst)[2]);
void copySideband(char (&src)[2], Sideband *dst);
void copySideband(char (&src)[2], Flit *dst);
void copySideband(char (&src)[2], char (&dst)[2]);

int tokenizeString(const char *&string, char **&tokens);

long xtrLongPar(cMessage *msg, const char* name);
void addLongPar(cMessage *msg, const char* name, long value);
void addCStringPar(cMessage *msg, const char* name, const char* value);

char *newBuff(int l);

#define WATCH_FLAG(var) (new cGenericAssignableWatch<char>((#var), (char&)(var)))

void watchFlag(const char *name, char &var);

}

#endif /* UTIL_H_ */
